% sta bgn
sta_decoded = zeros(1,noPDUs);
sta_SFhist = zeros(1,length(alltx_sig));
for h=1:length(alltx_sig)
    sta_SFhist(h) = alltx_sig{h}.SF;
end
% sta end

rxFiltSignalall = cell(1, RPMA_sample_attempt_num);
for satidx=1:RPMA_sample_attempt_num
    chadelay = (satidx-1)*sps/RPMA_sample_attempt_num;
    rxFiltSignalall{satidx} = rxSignal(chadelay+1:sps:end,:);
end
for SFidx=1:length(SFRange)
    if SFprob(SFidx) == 0 continue; end
    SF = SFRange(SFidx);
    for DELAYval=0:RPMA_intdelay_max + filtlen + sps 
        if noPDUs == 1
            if DELAYval > 10 break; end
            if USE_WRAPPER == 0
                fprintf(1,'working on SF %d, inten delay %d\n', SFidx,DELAYval)
            end
        end
        for SLOTidx=1:SFslotnum(SFidx)
            for satidx=1:RPMA_sample_attempt_num

                dbpskcodedfullSignal = zeros(RPMA_AP_ant_num,codedfullPDU_bit_num+1);
                CHIPSidx = 1;
                for bidx=1:codedfullPDU_bit_num+1
                    thisbgn = ((DELAYval + (SLOTidx-1)*SFslotlen(SFidx) + CHIPSidx)-1)+1;
                    thisend = thisbgn + SF - 1;
                    thissamples = rxFiltSignalall{satidx}(thisbgn:thisend,:);
                    thisvals = thissamples.*SFdemodseq{SFidx};
                    tempp = sum(thisvals);
                    dbpskcodedfullSignal(:,bidx) = tempp;
                    CHIPSidx = CHIPSidx + SF;
                end
                
                codedfullSignal = zeros(1,codedfullPDU_bit_num); 
                herecost = zeros(codedfullPDU_bit_num,2); 
                for bidx=1:codedfullPDU_bit_num
                    vec0 = dbpskcodedfullSignal(:,bidx);
                    vec1 = dbpskcodedfullSignal(:,bidx+1);
                    herecost(bidx,:) = ZCNET_cal_phase_symbol_cost([1,-1],vec0,vec1);
                    thisval = ZCNET_convert_phase_cost_to_prob(herecost(bidx,:));
                    thisvalscale = floor(thisval*power(2,trellis_soft_val_bit_num-1)); 
                    codedfullSignal(bidx) = thisvalscale + power(2,trellis_soft_val_bit_num-1);
                end
                
                deinterleaveSignal = randdeintrlv(codedfullSignal,interleave_S);
                
                decodedSignal = vitdec(deinterleaveSignal,trellis,traceback_depth,'term','soft', trellis_soft_val_bit_num); %'trunc'
                
                newCRCbits = transpose(crcGen2(transpose(decodedSignal(1:PDU_bit_num))));%generating CRC from data bits
                rxCRCbits = decodedSignal(PDU_bit_num+1:PDU_bit_num+CRC_bit_num);%extract CRC from PDU 
                if(isequal(newCRCbits(end-CRC_bit_num+1:end),rxCRCbits)) %if 2 CRCs are identical, compare with orignal PDUs
                    for PDUidx=1:noPDUs %compare original PDU with decoded PDU
                        [numErrors,ber] = biterr(alltx_sig{PDUidx}.crcbits,transpose(decodedSignal(1:PDU_bit_num+CRC_bit_num)));
                        if numErrors==0
                            fprintf('decoded PDU %d -- SF %d, slot %d, delay %d, satidx %d, error %d \n', ...
                            PDUidx,SF,SLOTidx,DELAYval,satidx,numErrors)
                            sta_decoded(PDUidx) = 1;
                            break;
                        end
                    end
                end
            end
        end
    end
end

% sta bgn
sta_SF_decoded = zeros(length(SFRange),2);
for SFidx=1:length(SFRange)
    if SFprob(SFidx) == 0 continue; end
    SF = SFRange(SFidx);
    AAA = find(sta_SFhist == SF); 
    sta_SF_decoded(SFidx,:) = [sum(sta_decoded(AAA)), length(AAA)];
end
% sta end