% input: SF, SFidx
% output: thisPDU, thisbasesig, thisnormsig

thisPDU.seed = ceil(rand(1)*1000000);
thisPDU.bits = round(rand(PDU_bit_num,1));
thisPDU.crcbits = crcGen2(thisPDU.bits);
thisPDU.crcbits_w_tail = vertcat(thisPDU.crcbits, zeros(Viterbi_trail_bit_num,1));
thisPDU.codeb4interleaving = transpose(convenc(transpose(thisPDU.crcbits_w_tail),trellis));
thisPDU.code = transpose(randintrlv(transpose(thisPDU.codeb4interleaving),interleave_S)); 
thisPDU.dbpskcode = zeros(1,length(thisPDU.code)+1);
for h=1:length(thisPDU.code)
    if thisPDU.code(h)
        thisPDU.dbpskcode(h+1) = xor(thisPDU.dbpskcode(h),1);
    else
        thisPDU.dbpskcode(h+1) = thisPDU.dbpskcode(h);
    end
end

thistxmod = zeros(length(thisPDU.dbpskcode)*SF,1);
for bidx=1:length(thisPDU.dbpskcode)
    t = SF*(bidx-1)+1;
    tempp = xor(thisPDU.dbpskcode(bidx),SFmodseq{SFidx});
    thistxmod(t:t+SF-1) = bpskModulator(tempp);  
end
thisbasesig = upfirdn(thistxmod,rrcFilter,sps,1);   
chcfg.Seed = thisPDU.seed;
tempp = lteFadingChannel(chcfg,thisbasesig);
thisnormsig = tempp/sqrt(sum(sum(tempp.*conj(tempp)))/numel(tempp)); 
bpskModulator.release;