RPMA_PDU_batch_size = 2;
thisbatchsig = zeros(RPMA_MAX_FRAM_Sample_num,1);

alltx_sig = cell(1,noPDUs);
cleanrxsignal = zeros(RPMA_MAX_FRAM_Sample_num,RPMA_AP_ant_num);
for PDUidx=1:noPDUs
    
    % rtemp = rand(1); tempp = find(SFprobsum>rtemp); SFidx = tempp(1);
    SFidx = sim_PDU_SF(PDUidx);
    SF = SFRange(SFidx);

    thisPDUinbatchidx = mod(PDUidx-1,RPMA_PDU_batch_size);
    if thisPDUinbatchidx == 0
        thisbatchamp = sqrt(SFtxPower(SFidx))* sqrt(1 + rand(1)*(power(RPMA_amp_max,2)-1));
        thisbatchcfo = (rand(1)-0.5)*2*RPMA_CFO_max;
        thisbatchchannseed = ceil(rand(1)*1000000);
        tempp = randperm(SFslotnum(SFidx)); thisbatchslot = sort(tempp(1:RPMA_PDU_batch_size));
        thisbatchsig(:,:) = 0;
    end
    
    thisPDU.bits = round(rand(PDU_bit_num,1));
    thisPDU.crcbits = crcGen2(thisPDU.bits);
    thisPDU.crcbits_w_tail = vertcat(thisPDU.crcbits, zeros(Viterbi_trail_bit_num,1));
    thisPDU.codeb4interleaving = transpose(convenc(transpose(thisPDU.crcbits_w_tail),trellis));
    thisPDU.code = transpose(randintrlv(transpose(thisPDU.codeb4interleaving),interleave_S)); 
    thisPDU.dbpskcode = zeros(1,length(thisPDU.code)+1);
    for h=1:length(thisPDU.code)
        if thisPDU.code(h)
            thisPDU.dbpskcode(h+1) = xor(thisPDU.dbpskcode(h),1);
        else
            thisPDU.dbpskcode(h+1) = thisPDU.dbpskcode(h);
        end
    end

    thistxmod = zeros(length(thisPDU.dbpskcode)*SF,1);
    for bidx=1:length(thisPDU.dbpskcode)
        t = SF*(bidx-1)+1;
        tempp = xor(thisPDU.dbpskcode(bidx),SFmodseq{SFidx});
        thistxmod(t:t+SF-1) = bpskModulator(tempp);  
    end
    bpskModulator.release; 
    thisbasesig = upfirdn(thistxmod,rrcFilter,sps,1);   
    thisPDU.seed = thisbatchchannseed;
        
    alltx_sig{PDUidx} = thisPDU;
    
    alltx_sig{PDUidx}.SF = SF;
    alltx_sig{PDUidx}.slotidx = thisbatchslot(thisPDUinbatchidx+1);
    alltx_sig{PDUidx}.intdelay = ceil(rand(1)*RPMA_intdelay_max);
    alltx_sig{PDUidx}.chandelay = floor(rand(1)*sps);
    alltx_sig{PDUidx}.cfo = thisbatchcfo; 
    alltx_sig{PDUidx}.amp = thisbatchamp;

    if noPDUs == RPMA_PDU_batch_size % for debugging
        alltx_sig{PDUidx}.slotidx = thisPDUinbatchidx + 1; 
        alltx_sig{PDUidx}.intdelay = 1; 
        alltx_sig{PDUidx}.chandelay = 3;   
        % alltx_sig{PDUidx}.cfo = 20;
    end
    
    hereradfreq = 2*pi/((1/alltx_sig{PDUidx}.cfo)*chcfg.SamplingRate);
    thisrotationwave_0 = exp(i*[0:length(thisbasesig)-1]*hereradfreq);
    thistxsig = thisbasesig.*transpose(thisrotationwave_0);
    
    alltx_sig{PDUidx}.sigbgn = ((alltx_sig{PDUidx}.slotidx-1)*SFslotlen(SFidx)+alltx_sig{PDUidx}.intdelay)*sps + alltx_sig{PDUidx}.chandelay + 1;
    thisbgn = thisPDUinbatchidx * length(thistxsig) + 1; % alltx_sig{PDUidx}.sigbgn;
    thisend = thisbgn + length(thistxsig) - 1;
    thisbatchsig(thisbgn:thisend,:) = thisbatchsig(thisbgn:thisend,:) + thistxsig;
    
    % if noPDUs <= 25
    %     alltx_sig{PDUidx}.basesig = thisbasesig;
    %     alltx_sig{PDUidx}.rxsig = thisrxsig;
    % end

    fprintf('gen PDU %d -- SF %d, slot %d, delay %d, chandelay %d, SNR (eq ZCNET) %.2f dB, cfo %.2f Hz\n', ...
                        PDUidx,SF,alltx_sig{PDUidx}.slotidx, ...
                        alltx_sig{PDUidx}.intdelay,...
                        alltx_sig{PDUidx}.chandelay,...
                        log10(power(alltx_sig{PDUidx}.amp,2)*RPMA_noise_factor_vs_ZCNET)*10, ...
                        alltx_sig{PDUidx}.cfo)
                    
                    
    if thisPDUinbatchidx == RPMA_PDU_batch_size - 1
        tempp = find(thisbatchsig);
        thisbatchbgn = tempp(1);
        thisbatchend = tempp(end);
        thisbatchnzsig = thisbatchsig(thisbatchbgn:thisbatchend);
        chcfg.Seed = thisbatchchannseed;
        tempp = lteFadingChannel(chcfg,thisbatchnzsig);
        thisnormsig = tempp/sqrt(sum(sum(tempp.*conj(tempp)))/numel(tempp)); 
        thisPDUsiglen = floor(size(thisnormsig,1)/RPMA_PDU_batch_size);
        for zzz=1:RPMA_PDU_batch_size
            thisPDUbgn = alltx_sig{PDUidx-RPMA_PDU_batch_size+zzz}.sigbgn;
            thisPDUend = thisPDUbgn + thisPDUsiglen - 1;
            thisbgn = (zzz-1)*thisPDUsiglen+1;
            thisend = thisbgn + thisPDUsiglen - 1;
            thisPDUsig = thisnormsig(thisbgn:thisend, :);
            cleanrxsignal(thisPDUbgn:thisPDUend,:) = cleanrxsignal(thisPDUbgn:thisPDUend,:) + thisPDUsig*thisbatchamp;
        end
    end            

end
noisesig = (randn(size(cleanrxsignal)) + i*randn(size(cleanrxsignal)))/sqrt(2);
rxSignal = cleanrxsignal + noisesig;

fprintf('RPMA sim PDU gen completed...\n');