RPMA_AP_ant_num = 2;

interleave_S = 225;

sps = 4; % orig: 4. Number of samples per symbol (oversampling factor)
filtlen = 5; % Filter length in symbols
rolloff = 0.25; % Filter rolloff factor
rrcFilter = rcosdesign(rolloff,filtlen,sps);

RPMA_intdelay_max = 2047;

poly = [32,26,23,22,16,12,11,10,8,7,5,4,2,1,0];
crcGen2 = comm.CRCGenerator(...
    'Polynomial', poly, ...
    'InitialConditions', 1, ...
    'DirectMethod', true, ...
    'FinalXOR', 1);

% trellis = struct('numInputSymbols',2,'numOutputSymbols',4, 'numStates',4,'nextStates',[0 2;0 2;1 3;1 3],'outputs',[0 3;1 2;3 0;2 1]);
herepoly = {'1 + x^2 + x^3 + x^5 + x^6', '1 + x + x^2 + x^3 + x^6'}; trellis = poly2trellis(7, herepoly);
traceback_depth = 32; % orig: 2
trellis_soft_val_bit_num = 8;
Viterbi_trail_bit_num = 6;
conv_code_rate = 1/2;
Viterbi_use_soft_decoding = 1;

bpskModulator = comm.BPSKModulator;

%1.1 fadding channel
chcfg.DelayProfile = 'ETU';
chcfg.InitPhase='random';
chcfg.DopplerFreq = 5; %  Doppler frequency
chcfg.MIMOCorrelation = 'Low'; % Low (no) MIMO correlation
chcfg.InitTime = 0; % Initialize at time zero
chcfg.NTxAnts = 1;
chcfg.NRxAnts = RPMA_AP_ant_num;
chcfg.NTerms = 16;
chcfg.NormalizeTxAnts = 'On';
chcfg.NormalizePathGains = 'On';
chcfg.SamplingRate = 1000000*sps;
chcfg.delay = 0;
chcfg.ModelType = 'GMEDS';
chcfg.Seed = 1;

RPMA_receriver_oversample = 0;

RPMA_noise_factor_vs_ZCNET = chcfg.SamplingRate/125000;
if RPMA_receriver_oversample == 0
    RPMA_noise_factor_vs_ZCNET = RPMA_noise_factor_vs_ZCNET/sps;
end

SFRange = [512 1024 2048 4096];

goldseq_old = comm.GoldSequence('FirstPolynomial','x^11+x^2+1',...
    'SecondPolynomial','x^11+x^8+x^5+x^2+1',...
    'FirstInitialConditions',[0 0 0 0 0 0 0 0 0 0 1],...
    'SecondInitialConditions',[0 0 0 0 0 0 0 0 0 0 1],...
    'Index',11,'VariableSizeOutput',1,'MaximumOutputSize',[2047 1]);
goldseqold_2048 = [transpose(goldseq_old(2047)) 1];

goldseq = comm.GoldSequence('FirstPolynomial','x^9+x^4+1',...
    'SecondPolynomial','x^9+x^6+x^4+x^3+1',...
    'FirstInitialConditions',[0 0 0 0 0 0 0 0 1],...
    'SecondInitialConditions',[0 0 0 0 0 0 0 0 1],...
    'Index',11,'VariableSizeOutput',1,'MaximumOutputSize',[512 1]);

goldseq1 = comm.GoldSequence('FirstPolynomial','x^10+x^3+1',...
    'SecondPolynomial','x^10+x^8+x^3+x^2+1',...
    'FirstInitialConditions',[0 1 0 0 1 0 0 0 0 1],...
    'SecondInitialConditions',[0 1 0 0 1 0 0 0 0 1],...
    'Index',11,'VariableSizeOutput',1,'MaximumOutputSize',[1024 1]);

goldseq2 = comm.GoldSequence('FirstPolynomial','x^11+x^2+1',...
    'SecondPolynomial','x^11+x^8+x^5+x^2+1',...
    'FirstInitialConditions',[0 1 1 0 0 0 0 0 0 0 1],...
    'SecondInitialConditions',[0 1 1 0 0 0 0 0 0 0 1],...
    'Index',11,'VariableSizeOutput',1,'MaximumOutputSize',[2048 1]);

goldseq3 = comm.GoldSequence('FirstPolynomial','x^11+x^2+1',...
    'SecondPolynomial','x^11+x^8+x^5+x^2+1',...
    'FirstInitialConditions',[1 1 0 0 0 1 1 0 0 0 1],...
    'SecondInitialConditions',[1 1 0 0 0 1 0 1 0 0 1],...
    'Index',11,'VariableSizeOutput',1,'MaximumOutputSize',[4096 1]);

SFmodseq = cell(1,4);
SFmodseq{1} = goldseq(512);
SFmodseq{2} = goldseq1(1024);
SFmodseq{3} = goldseqold_2048'; goldseq2(2048);
SFmodseq{4} = goldseq3(4096);

SFdemodseq = cell(1,length(SFRange));
for h=1:length(SFRange)
    tempp = bpskModulator(SFmodseq{h});   
    SFdemodseq{h} = repmat(tempp,1,RPMA_AP_ant_num);   
    bpskModulator.release;
end

SFslotnum = [16,8,4,2];
SFslotlen = 2300000./SFslotnum;

PDU_bit_num = 90;
CRC_bit_num = 32;
fullPDU_bit_num = PDU_bit_num + CRC_bit_num + Viterbi_trail_bit_num;
codedfullPDU_bit_num = floor(fullPDU_bit_num/conv_code_rate);

RPMA_MAX_FRAM_Sample_num = (max(SFslotlen.*SFslotnum) + RPMA_intdelay_max)*sps + 1000;
RPMA_CFO_max = 25; 
RPMA_sample_attempt_num = 2;

RPMA_simu_PDU_file_num = 1000;
USE_WRAPPER = 0;